proc displayMiniImage {} {
	# display a new toplevel window with a minature copy of the graphics
	global plugin widget

	# recreate all objects (minituarized by factor FACTOR)
	set FACTOR 0.2
  set minx 0
  set miny 0
  foreach n [lsort [allEntries P]] {
		set color #ddff78
		if {$plugin($n,p_start)==1} {set color yellow}
		createBox $widget(overview,c) \
			$plugin($n,x) $plugin($n,y) \
			$color \
			$n \
			"" \
			"" \
			[expr \$plugin($n,p_follows)=={}] \
			$FACTOR
		if {$plugin($n,x)>$minx} {set minx $plugin($n,x)}
		if {$plugin($n,y)>$miny} {set miny $plugin($n,y)}
  }
  foreach n [lsort [allEntries Q]] {
		createBox $widget(overview,c) \
			$plugin($n,x) $plugin($n,y) \
			#ffa850 \
			$n \
			"" \
			"" \
			[expr \$plugin($n,q_follows)=={}] \
			$FACTOR
		if {$plugin($n,x)>$minx} {set minx $plugin($n,x)}
		if {$plugin($n,y)>$miny} {set miny $plugin($n,y)}
  }

	# recreate all connections
  foreach n [lsort [allEntries P]] {
		foreach tmp $plugin($n,p_follows) {
			connectRectangles $widget(overview,c) $n $tmp none black 1 $FACTOR
		}
  }
  foreach n [lsort [allEntries Q]] {
		foreach tmp $plugin($n,q_follows) {
			connectRectangles $widget(overview,c) $n $tmp none black 1 $FACTOR
		}
  }
  
	# set the correct scrollregion
	$widget(overview,c) configure -scrollregion [$widget(overview,c) bbox all]
}

proc miniDisplay {id} {
	global widget
	
	set tag [bboxTag $id]

	# delete old markers
	$widget(overview,c) delete minimarkers

	# after http://wiki.tcl.tk/9264
  foreach {x1 y1 x2 y2} [$widget(overview,c) bbox $tag] break
  foreach {s1 t1 s2 t2} [$widget(overview,c) cget -scrollregion] break
	#set width [$widget(overview,c) cget -width]
	#set height [$widget(overview,c) cget -height]
	set width [winfo reqwidth $widget(overview,c)]
	set height [winfo reqheight $widget(overview,c)]
  $widget(overview,c) xview moveto [expr {double($x1 -0.5*($width-$x2+$x1) - $s1) / ($s2 - $s1)}]
  $widget(overview,c) yview moveto [expr {double($y1 -0.5*($height-$y2+$y1) - $t1) / ($t2 - $t1)}]

	# draw new markers to highlight the current object
	$widget(overview,c) create rectangle \
		[expr $x1-2] [expr $y1-2] [expr $x2+2] [expr $y2+2] \
		-width 2 -outline red -tags minimarkers
}
