# =============================================================================
# Wizard of Oz - Runtime module
# =============================================================================
#	Version			{VERSION}
#	Date				{VERSION_DATE}
#
#	Startprompt	{STARTPROMPT}
#	WOZ-Dir			{WOZDIR}
#
#	Title				{TITLE_MAIN}
#	TTS Prompts	{TTS_PROMPT}
# =============================================================================

# =============================================================================
#	This file has been generated with WOZ - do not edit!
# =============================================================================

set plugin(wav) ""
set plugin(pic) ""
set plugin(autoplay) 1
set plugin(autostop) 1

set options(CONDLENGTH) 20

#-------------------------------------------------------------------------- TCL
# check tcl version
if {$tcl_version<"8.3"} {
  puts "FATAL ERROR:\n\nTcl/Tk must be at least version 8.3!"
  exit
}
# check tk availability
if {[info commands button]==""} {
  puts "FATAL ERROR:\n\nThis program requires wish!"
  exit
}

wm withdraw .

# ----------------------------------------------------------------------- SNACK
# WOz needs snack >=2.2 to replay sound files
if {[catch {set woz(snack) [package require snack]}]} {
	set woz(snack) ""
	tk_messageBox -type ok -message "WARNING:\n\nPackage 'snack' is not installed!\nWOz cannot play soundfiles."
} elseif {$woz(snack)<"2.2"} {
	set woz(snack) ""
	tk_messageBox -type ok -message "WARNING:\n\nPackage 'snack' is too old, v2.2 is required!\nWOz cannot play soundfiles."
}

# ------------------------------------------------------------------------- DIR
# get script root
set woz(DIR) "[file dirname [info script]]"
if {$woz(DIR)==""} {
  # correct this if you want to source...
  set woz(DIR) .
}

# check script root
if {![file exists $woz(DIR)/share/run.tcl]} {
	set woz(DIR) "{WOZDIR}"
}
if {![file exists $woz(DIR)/share/run.tcl]} {
  tk_messageBox -type ok -message "FATAL ERROR:\n\nCannot determine script root directory.
Copy the export/share folder from WOz under your new script!"
	exit
}

# ----------------------------------------------------------------------- TCOM
# WOz needs tcom >=3.7 to create TTS output
if {[catch {set woz(tcom) [package require tcom]}]} {
	set woz(tcom) ""
	tk_messageBox -type ok -message "WARNING:\n\nPackage 'tcom' is not installed!\nWOz cannot play TTS prompts."
} elseif {$woz(tcom)<"3.7"} {
	set woz(tcom) ""
	tk_messageBox -type ok -message "WARNING:\n\nPackage 'tcom' is too old, v2.2 is required!\nWOz cannot play TTS prompts."
}

# ----------------------------------------------------------------------- SAPI
if {$woz(tcom)!=""} {
	if {[catch {set woz(sapi) [::tcom::ref createobject Sapi.SpVoice]}]} {
		set woz(sapi) ""
		tk_messageBox -type ok -message "WARNING:\n\nNo SAPI voice is installed!\nWOz cannot play TTS prompts."
		set var(tts) 0
	} else {
		set var(tts) {MENU_RUN_TTS_ON}
	}
}

# ------------------------------------------------------------------------- LOG
# get log file name
set woz(LOGFILE) "[file rootname [info script]].log"

#-------------------------------------------------------------------------- RES
set woz(RES) $woz(DIR)/share
set woz(sort) 1
set plugin(restrictive) 1
set plugin(currentid) {STARTPROMPT}
set woz(win_choose) "{TITLE_PROMPT}"
set woz(win_entertts) "{TTS_PROMPT}"

proc splash {{ms 0}} {
    global woz
    update idletasks
    if {[winfo exists .x]} return
    toplevel .x -bd 3 -relief raised
    wm withdraw .x
    set sw [winfo screenwidth .]
    set sh [winfo screenheight .]
    image create photo "title" -file $woz(RES)/woz.gif
    wm overrideredirect .x 1
    label .x.l -image title -bd 1 -relief sunken
    frame .x.f
    label .x.f.a -bd 1 -relief raised -background yellow -text "{VERSION} - {VERSION_DATE}"
    button .x.f.b -command {catch {grab release .x; destroy .x}} -textvar label(close)
    pack .x.l -side top -expand 1 -fill both
    pack .x.f.a -side left -expand 1 -fill both
    pack .x.f.b -side left
    pack .x.f -side top -fill x
    set x [expr {($sw - [image width title])/2}]
    set y [expr {($sh - [image height title])/2}]
    wm geometry .x +$x+$y
    wm deiconify .x
    raise .x
    focus .x
    if {$ms==0} {
	    bind .x <Key-Return> {.x.f.b invoke}
	    bind .x <Key-Escape> {.x.f.b invoke}
    }
    update idletasks
    if {$ms>0} {
      after $ms {catch {destroy .x}}
    } else {
      grab .x
      tkwait window .x
    }
}

proc log {str} {
  global woz

  # replace newlines in the log string by ~ to create a smoother output
  regsub -all "\n" $str "~" str

  # log the string with a time stamp
  puts $woz(log) "[clock format [clock seconds] -format "%y%m%d%H%M%S"]\t$str"
}

proc logDia {id which who str} {
  global woz

  # replace newlines in the log string by ~ to create a smoother output
  regsub -all "\n" $str "~" str

  # log the string with a time stamp
  puts $woz(dia) "$id\t$which\t$who\t$str"
}

#========================================================================= MAIN
cd $woz(DIR)
source $woz(RES)/run.tcl
source $woz(RES)/util.tcl
source $woz(RES)/balloon.tcl
source $woz(RES)/undo.tcl
source $woz(RES)/dia.tcl
source $woz(RES)/play.tcl
source $woz(RES)/canvas.tcl
source $woz(RES)/mini.tcl
source $woz(RES)/ini.tcl

ini::Read $woz(RES)/run.ini
set woz(wav_dir) "{WAVDIR}"

# initializations
set woz(log) [open $woz(LOGFILE) a]
puts $woz(log) "-------------------------------------------------------------------------------"
log "WOZ Session started ({VERSION})"
moveInit

array set plugin {
        pix,vars        {p_id p_follows p_start p_title}
        pix,text        {p_prompt p_memo}
        qix,vars        {q_id q_concepts q_follows q_title}
        qix,text        {q_memo q_init q_nu1 q_nu2 q_nu3 q_nr1 q_nr2 q_nr3 q_tl1 q_tl2 q_tl3 q_ctxhelp}
        cix,vars        {c_id c_name c_always c_title}
        cix,text        {c_memo}
}

array set plugin {
{PLUGINARRAY}
}

array set label {
{LABELARRAY}
}

array set options {
{OPTIONSARRAY}
}

initCanvas

proc rNum {} {
  # produce a random number between 0 and 100
  return [expr round(100.0*rand())]
}

proc throwEvent {str} {
  global widget label

  log "Event|$str"

  set label(exc) $str
  Window show $widget(winexc)
  grab $widget(winexc)
  focus $widget(winexc)
  raise $widget(winexc)
  tkwait window $widget(winexc)
}

proc allEntries {type} {
  global plugin
 
  # return a list of all ids from a certain type
  set ret {}
  set tmp [array names plugin *,[string tolower $type]_id]
  foreach n [lsort $tmp] {
    lappend ret [lindex [split $n ","] 0]
  }
  return $ret
}

proc resortList {} {
  global woz widget
  #puts "sorting order is now $woz(sort)"
 
  proc cmpEl {a b} {
    global woz
    set la [split $a "|"]
    set lb [split $b "|"]
    if {[lindex $la $woz(sort)]<[lindex $lb $woz(sort)]} {return -1}
    if {[lindex $la $woz(sort)]>[lindex $lb $woz(sort)]} {return 1}
    return 0
  }
 
  set elList [$widget(followlist) get 0 end]
  set elList [lsort -command cmpEl $elList]
  $widget(followlist) delete 0 end
  foreach e $elList {
    $widget(followlist) insert end $e
    if {[string index $e 0]=="P"} {
      $widget(followlist) itemconfigure end -background [ini::Str common.colorP]
    } else {
      $widget(followlist) itemconfigure end -background [ini::Str common.colorQ]
    }
  }
}

proc getAndSwitch {} {
  # get the current followup selection and switch to it
  global widget
 
  # get the current selection index
  set sel [$widget(followlist) curselection]
  if {$sel==""} {return}
 
  # get the selected element
  set sel [$widget(followlist) get $sel]
  if {$sel==""} {return}
 
  # the the interesting part before |
  set p [string first "|" $sel]
  if {$p==-1} {return}
  set sel [string range $sel 0 [expr $p-1]]
 
  # switch to that element
  switchAndStore $sel
}

proc switchAndStore {id} {
  global plugin

  # store move for undo/redo
  moveAdd "switchEntry $id" "switchEntry $plugin(currentid)"
}

proc ableButtons {id field} {
	global plugin widget
	
	if {$plugin($id,[set field]_bi) && $plugin($id,$field)!=""} {
		$widget(stop,$field) configure -state normal
	} else {
		$widget(stop,$field) configure -state disabled
	}
	if {$plugin($id,$field)!=""} {
		$widget(ls,$field) configure -state normal
	} else {
		$widget(ls,$field) configure -state disabled
	}
}

proc isPrompt {id} {
	if {[string tolower [string index $id 0]]=="p"} {return 1}
	return 0
}

proc isQuestion {id} {
	if {[string tolower [string index $id 0]]=="q"} {return 1}
	return 0
}

proc isConnected {tag1 tag2} {
	global plugin

	# check for always reachable target
	if {[isPrompt $tag2]} {
		if {$plugin($tag2,p_reachable)==1} {return 1}
	} else {
		if {$plugin($tag2,q_reachable)==1} {return 1}
	}

	# examine the follows list
	if {[isPrompt $tag1]} {set w p_follows} else {set w q_follows}
	return [expr [lsearch -exact $plugin($tag1,$w) $tag2]!=-1]
}

proc calcSuccessors {id} {
	# return a list of follow up id's
	global plugin

	set ret {}
	foreach n [concat [allEntries P] [allEntries Q]] {
		if {[isConnected $id $n]} {lappend ret $n}
	}

	return [lsort -uniq $ret]
}

proc switchEntry {id} {
  # switch to prompt or question
  global widget plugin global status options curobj

  # empty the destroy event
  bind $widget(main) <Destroy> {}

  # remove the old windows
  catch {pack unpack $widget(p)}
  catch {pack unpack $widget(q)}
  $widget(followlist) delete 0 end

  # pack the right one
  set type [string tolower [string index $id 0]]
  pack $widget($type) -expand 1 -fill both

  # show the current status information
  incr global(turns)
  set status(turns) "$global(turns) {TURNS}"
  set plugin(currentid) $id

  # set the appropriate values
  switch $type {
    p {
      # write logs
      log "$global(turns)|$id|$plugin($id,p_title)|$plugin($id,p_prompt)"

      foreach n $plugin(pix,vars) { set curobj($n) $plugin($id,$n) }
      foreach n $plugin(pix,text) {
        $widget($n) delete 0.0 end
        $widget($n) insert end $plugin($id,$n)
      }

			# configure stop and play buttons
			ableButtons $id p_prompt

      # in non restrictive mode all entries can be reached
      if {$plugin(restrictive)} {
				if {$plugin($id,p_endstate)==1} {
				  set status(msg) "Switched to $id (end state)"
	        set list {}
				} else {
				  set status(msg) "Switched to $id"
	        set list [calcSuccessors $id]
				}
      } else {
        set list [concat [allEntries P] [allEntries Q]]
      }

      # create a button for each possible followup
      catch {eval destroy [winfo children $widget(p_follows)]}
      foreach n $list {
        if {[string index $n 0]=="P"} {
          $widget(followlist) insert end "$n|[util::value plugin(O,$id,$n) $options(CONDLENGTH)]|$plugin($n,p_title)|$plugin($n,p_prompt)"
        } else {
          $widget(followlist) insert end "$n|[util::value plugin(O,$id,$n) $options(CONDLENGTH)]|$plugin($n,q_title)|$plugin($n,q_init)"
        }
      }

			# autoplay
			if {$plugin(autoplay)} {
				after 0 {playPrompt p_prompt}
			}
    }
    q {
      # write logs
      log "$global(turns)|$id|$plugin($id,q_title)|$plugin($id,q_init)"

      foreach n $plugin(qix,vars) { set curobj($n) $plugin($id,$n) }
      foreach n $plugin(qix,text) {
        $widget($n) delete 0.0 end
        $widget($n) insert end $plugin($id,$n)
      }

			# configure stop and play buttons
			ableButtons $id q_init
			ableButtons $id q_nu1
			ableButtons $id q_nu2
			ableButtons $id q_nu3
			ableButtons $id q_nr1
			ableButtons $id q_nr2
			ableButtons $id q_nr3
			ableButtons $id q_tl1
			ableButtons $id q_tl2
			ableButtons $id q_tl3
			ableButtons $id q_ctxhelp

      # in non restrictive mode all entries can be reached
      if {$plugin(restrictive)} {
				if {$plugin($id,q_endstate)==1} {
				  set status(msg) "Switched to $id (end state)"
	        set list {}
				} else {
				  set status(msg) "Switched to $id"
	        set list [calcSuccessors $id]
				}
      } else {
        set list [concat [allEntries P] [allEntries Q]]
      }

      # create a button for each possible followup
      catch {eval destroy [winfo children $widget(q_follows)]}
      foreach n $list {
        if {[string index $n 0]=="P"} {
          $widget(followlist) insert end "$n|[util::value plugin(O,$id,$n) $options(CONDLENGTH)]|$plugin($n,p_title)|$plugin($n,p_prompt)"
        } else {
          $widget(followlist) insert end "$n|[util::value plugin(O,$id,$n) $options(CONDLENGTH)]|$plugin($n,q_title)|$plugin($n,q_init)"
        }
      }

      # create a (disabled) button for each concept
      catch {eval destroy [winfo children $widget(q_concepts_alw)]}
      catch {eval destroy [winfo children $widget(q_concepts)]}

      foreach n [lsort $plugin(alw)] {
				set w [string tolower $widget(q_concepts_alw).$n]
        button $w -text "$plugin($n,c_title)" -state disabled -background [ini::Str common.colorC] \
        	-disabledforeground #000040
        set tmp "$plugin($n,c_name) - $plugin($n,c_memo)"
        if {[string length $tmp]>[ini::Str common.conceptBubbleLength]} {
					set tmp "[string range $tmp 0 [expr [ini::Str common.conceptBubbleLength]-1]]..."
				}
				balloon $w $tmp
	      pack $w -side left
			}

	    foreach n [lsort $plugin($id,q_concepts)] {
				set w [string tolower $widget(q_concepts).$n]
		    button $w -text "$plugin($n,c_title)" -state disabled -background [ini::Str common.colorC] \
		    	-disabledforeground #000040
		    set tmp "$plugin($n,c_name) - $plugin($n,c_memo)"
        if {[string length $tmp]>[ini::Str common.conceptBubbleLength]} {
					set tmp "[string range $tmp 0 [expr [ini::Str common.conceptBubbleLength]-1]]..."
				}
				balloon $w $tmp
		    pack $w -side left
		  }

			# autoplay
			if {$plugin(autoplay)} {
				after 0 {playPrompt q_init}
			}
	  }
	}

  # sort the list
  resortList

	# display the mini entry
	miniDisplay $id

  # re-restablish the destroy event
  bind $widget(main) <Destroy> {menuCommand file,exit}

  if {$type=="q" && $plugin(exc)==1} {
    # generate a random event from time to time
    if {[rNum]<$options(exc_nu)} {
      throwEvent "{NU}"
    } elseif {[rNum]<$options(exc_nr)} {
      throwEvent "{NR}"
    } elseif {[rNum]<$options(exc_tl)} {
      throwEvent "{TL}"
    } elseif {[rNum]<$options(exc_re)} {
      throwEvent "{RE}"
    }
  }
}

proc menuCommand {cmd} {
  global global woz
  switch $cmd {
    file,exit {
      catch {close $woz(log)}
      catch {close $woz(dia)}
      exit
    }
    run,restart {
      log "Restart -------------------------------------------------------------------------------"
      set global(time) [clock seconds]
      set global(turns) 0

			# create a dialog log
			catch {close $woz(dia)}
			set woz(DIAFILE) "$woz(rootname).[clock format [clock seconds] -format %y%m%d%H%M%S].log"
			set woz(dia) [open $woz(DIAFILE) w]

      switchEntry {STARTPROMPT}
    }
    run,undo {
      log "Undo"
      logDia "" "" "<undo>" "..."
      moveUndo
    }
    run,redo {
      log "Redo"
      logDia "" "" "<Redo>" "..."
      moveRedo
    }
    help,about {
      splash
    }
  }
}

proc setTime {} {
  global status global

  set status(time) [clock format [expr [clock seconds]-$global(time)] -format "%M:%S"]
  after 1000 setTime
}

proc setDate {} {
  global status

  set status(date) [clock format [clock seconds] -format "%c"]
}

proc playPrompt {which} {
	global cmd plugin status
	
	log "play|$plugin(currentid)|$which|$plugin($plugin(currentid),$which)"
  logDia $plugin(currentid) $which "System" "$plugin($plugin(currentid),$which)"

	if {$plugin(autostop)} {
		catch {$plugin(wav) destroy}
	}

	set plugin(wav) [play::prompt $plugin($plugin(currentid),$which) 1]
	if {$plugin(wav)!=""} {
		$plugin(wav) play
		set destroyAfter [expr 2+round(1000*[$plugin(wav) length -unit SECONDS])]
		after $destroyAfter "catch \"$plugin(wav) destroy\""
	}

	set plugin(pic) [play::picture $plugin($plugin(currentid),$which)]
}

proc stopPrompt {which} {
	global cmd plugin status

	catch {$plugin(wav) stop}
	catch {destroy $plugin(pic)}
}

displayMiniImage

# calculate a list of always active concepts
set plugin(alw) {}
foreach n [array names plugin C*,c_id] {
  set id [lindex [split $n ","] 0]
  if {$plugin($id,c_always)==1} {lappend plugin(alw) $id}
}

# set window titles
wm title $widget(main) "{TITLE_MAIN}"
wm title $widget(winexc) "{TITLE_EXC}"

Window hide $widget(winexc)

# set language values
$widget(mm_file) configure -text "{MENU_FILE}"
$widget(mm_run)  configure -text "{MENU_RUN}"
$widget(mm_help) configure -text "{MENU_HELP}"

$widget(m_file) entryconfigure 0 -label "{MENU_FILE_EXIT}"

$widget(m_run)  entryconfigure 0 -label "{MENU_RUN_RESTART}"
$widget(m_run)  entryconfigure 2 -label "{MENU_RUN_UNDO}"
$widget(m_run)  entryconfigure 3 -label "{MENU_RUN_REDO}"
$widget(m_run)  entryconfigure 5 -label "{MENU_RUN_RESTRICTIVE}"
$widget(m_run)  entryconfigure 6 -label "{MENU_RUN_EXC}"
$widget(m_run)  entryconfigure 7 -label "{MENU_RUN_AUTOPLAY}"
$widget(m_run)  entryconfigure 8 -label "{MENU_RUN_AUTOSTOP}"
$widget(m_run)  entryconfigure 10 -label "{MENU_RUN_TTS}"

$widget(m_help) entryconfigure 0 -label "{MENU_HELP_ABOUT}"

if {$woz(sapi)==""} {
	$widget(m_run) entryconfigure 10 -state disabled
	set $var(tts) 0
} else {
	set $var(tts) {MENU_RUN_TTS_ON}
}

# remove the empty windows
catch {pack unpack $widget(p)}
catch {pack unpack $widget(q)}

image create photo "play" -file $woz(RES)/play.gif
image create photo "stop" -file $woz(RES)/stop.gif
foreach n {q_init q_nu1 q_nu2 q_nu3 q_nr1 q_nr2 q_nr3 q_tl1 q_tl2 q_tl3 q_ctxhelp \
           p_prompt} {
	$widget(ls,$n) configure -image "play" -command "playPrompt $n"
	$widget(stop,$n) configure -image "stop" -command "stopPrompt $n"
}

# set colors for labels
foreach n [array names widget label,c_*] {
	$widget($n) configure -background [ini::Str common.colorC]
}
foreach n [array names widget label,p_*] {
	$widget($n) configure -background [ini::Str common.colorP]
}
foreach n [array names widget label,q_*] {
	$widget($n) configure -background [ini::Str common.colorQ]
}

set global(time) [clock seconds]
set global(turns) 0
set woz(rootname) [file rootname [info script]]

setTime
setDate
bind $widget(main) <Destroy> {menuCommand file,exit}
#bind $widget(main) <Key-BackSpace> {menuCommand run,undo}
bind $widget(main) <Key-Delete> {menuCommand run,undo}
bind $widget(main) <Key-Insert> {menuCommand run,redo}
bind $widget(main) <Key-F1> {menuCommand help,about}
bind $widget(main) <Key-F2> {menuCommand run,restart}
bind $widget(main) <Key-Return> {$widget(logButton) invoke}
focus $widget(logEntry)

splash 2500

# replace {REPROMPTS} in all questions
foreach n [allEntries Q] {
	foreach name $plugin(qix,text) {
		regsub -all -nocase "{REPROMPT}" $plugin($n,$name) $plugin($n,q_init) plugin($n,$name)
	}
}


menuCommand run,restart
