##############################################################################
# $Id: balloon.tcl,v 1.2 1998/11/25 04:47:55 stewart Exp $
#
# balloon.tcl - procedures used by balloon help
#
# Copyright (C) 1996-1998 Stewart Allen
# Modified for the use outside vTcl by Richard Breuer [Feb, 19 2000]
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##############################################################################
#

set balloon(show) 1

bind balloon(balloon) <Enter> {
    set balloon(set) 0
    set balloon(first) 1
    set balloon(id) [after 500 {balloonShow %W $balloon(%W)}]
}

bind balloon(balloon) <Button> {
    set balloon(first) 0
    balloonKill
}

bind balloon(balloon) <Leave> {
    set balloon(first) 0
    balloonKill
}

bind balloon(balloon) <Motion> {
    if {$balloon(set) == 0} {
        catch {after cancel $balloon(id)}
        set balloon(id) [after 500 {balloonShow %W $balloon(%W)}]
    }
}

proc balloon {target message} {
    global balloon
    set balloon($target) $message
    bindtags $target "[bindtags $target] balloon(balloon)"
}

proc balloonKill {} {
    global balloon
    catch {after cancel $balloon(id)}
    if {[winfo exists .balloon] == 1} {
        destroy .balloon
    }
    set balloon(set) 0
}

proc balloonShow {target message} {
    global balloon
    if {$balloon(first) == 1 && $balloon(show) == 1} {
        set balloon(first) 2
        set x [expr {[winfo rootx $target] + ([winfo width $target]/2)}]
        set y [expr {[winfo rooty $target] + [winfo height $target] + 4}]
        toplevel .balloon -bg black
        wm overrideredirect .balloon 1
        label .balloon.l \
            -text $message -relief flat \
            -bg #ffffaa -fg black -padx 2 -pady 0 -anchor w
        pack .balloon.l -side left -padx 1 -pady 1
        wm geometry .balloon +${x}+${y}
        set balloon(set) 1
    }
}


