#==========================================================================================
#
#       Written by Richard Breuer (richard.breuer@gmx.de)
#
#==========================================================================================
# Sep 23, 2000  First Version [RB]
#==========================================================================================
namespace eval fort {

proc create {base {minI 1} {maxI 10} {title "Fortschritt"}} {
    variable widget 

    set widget($base,minI) $minI
    set widget($base,maxI) $maxI

    if {[winfo exists $base]} {
        wm deiconify $base; return
    }

    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    set sw [expr ([winfo screenwidth .]-140)/2]
    set sh [expr ([winfo screenheight .]-45)/2]
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm geometry $base +$sw+$sh
    wm deiconify $base

    wm title $base "Fortschritt"

    set widget($base,title) $title

    frame $base.fra32 \
        -borderwidth 2 -height 75 -width 125 
    label $base.fra32.lab48 \
        -borderwidth 1 -text ptitle -textvar fort::widget($base,title)
    frame $base.fra32.fra33 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    canvas $base.fra32.fra33.can38 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can39 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can40 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can41 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can42 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can43 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can44 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can45 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can46 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    canvas $base.fra32.fra33.can47 \
        -borderwidth 1 -height 15 -relief ridge -width 20
    label $base.fra32.lab49 \
        -borderwidth 1 -font {Helvetica -10} -text "" \
	-textvar fort::widget($base,message)

    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra32 \
        -in $base -anchor center -expand 0 -fill none -side top 
    pack $base.fra32.lab48 \
        -in $base.fra32 -anchor center -expand 0 -fill none -side top 
    pack $base.fra32.fra33 \
        -in $base.fra32 -anchor center -expand 0 -fill none -padx 15 \
        -pady 15 -side top 
    pack $base.fra32.fra33.can38 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can39 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can40 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can41 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can42 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can43 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can44 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can45 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can46 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.fra33.can47 \
        -in $base.fra32.fra33 -anchor center -expand 0 -fill none -side left 
    pack $base.fra32.lab49 \
        -in $base.fra32 -anchor center -expand 0 -fill none -side top 

    ###################
    # SETTING VALUES
    ###################
    set widget($base,p0) $base.fra32.fra33.can38
    set widget($base,p1) $base.fra32.fra33.can39
    set widget($base,p2) $base.fra32.fra33.can40
    set widget($base,p3) $base.fra32.fra33.can41
    set widget($base,p4) $base.fra32.fra33.can42
    set widget($base,p5) $base.fra32.fra33.can43
    set widget($base,p6) $base.fra32.fra33.can44
    set widget($base,p7) $base.fra32.fra33.can45
    set widget($base,p8) $base.fra32.fra33.can46
    set widget($base,p9) $base.fra32.fra33.can47

    display $base
}

proc display {base {current min} {fmt 3}} {
  # fmt	0 --> empty status line
  #	1 --> short status line "8.34 %"
  #	2 --> medium status line "19 (8.34 %)"
  #	3 --> long one "10 (of 1 to 10 = 100 %)
  variable widget

  # illegal limits
  if {$widget($base,minI)==$widget($base,maxI)} {return}

  # minimum
  if {$current=="min"} {set current $widget($base,minI)}

  # swap limits
  if {$widget($base,minI)>$widget($base,maxI)} {
    set tmp $widget($base,minI)
    set widget($base,minI) $widget($base,maxI)
    set widget($base,maxI) $tmp
  }

  # calc the canvases	 0.00- 9.99 --> 1 canvas
  #			10.00-19.99 --> 2 canvases
  #				    ...
  #			90.00-100.0 --> 10 canvases
  if {$current<=$widget($base,minI)} {
    set can 0
    set fac 0.0
  } elseif {$current>=$widget($base,maxI)} {
    set can 10
    set fac 1.0
  } else {
    set range [expr $widget($base,maxI)-$widget($base,minI)]
    set fac [expr (0.0+$current-$widget($base,minI))/(0.0+$range)]
    set can [expr 1+round(10.0*$fac)]
    if {$can>10} {set can 10}
  }

  # color the canvases
  for {set i 0} {$i<$can} {incr i} {
    $widget($base,p$i) configure -background red
  }
  for {set i $can} {$i<10} {incr i} {
    $widget($base,p$i) configure -background white
  }

  # create a message
  set prozent [format "%.2f" [expr 100.0*$fac]]
  switch $fmt {
	0 {
  	  set widget($base,message) ""
	}
	1 {
  	  set widget($base,message) "$prozent %"
	}
	2 {
  	  set widget($base,message) "$current ( $prozent % )"
	}
	default {
  	  set widget($base,message) "$current (of $widget($base,minI) to $widget($base,maxI) = $prozent % )"
	}
  }

  # store the current value
  set widget($base,current) $current
}

proc setTitle {base title} {
  variable widget
  set widget($base,title) $title
}

proc setLimits {base lower upper} {
  variable widget
  set widget($base,minI) $lower
  set widget($base,maxI) $upper

  # eventually redisplay the current value
  if {[info exists widget($base,current)]} {
    display $base $widget($base,current)
  }
}

proc destroy {base} {
  ::destroy $base
}

}
