#==========================================================================================
#
# 	Written by Richard Breuer (richard.breuer@gmx.de)
#
#==========================================================================================
# Feb 08, 2000	First version [RB]
#==========================================================================================

namespace eval set {

proc force {setvar element {existence 1}} {
  # force the [non-]existence of $element in the set
  upvar $setvar s

  set s [util::nodup $s]
  set p [lsearch -exact $s $element]
  if {$p==-1} {
    if {$existence} {lappend s $element}
  } else {
    if {!$existence} {set s [lreplace $s $p $p]}
  }
}

}