proc layout2image {fn {type png}} {
	# idea:display a new toplevel window with a copy of the graphics
	# make it small enough to be displayed on the screen
	# take snapshot of rasters and combine them until everything is complete
	global plugin

	# create a new temporary toplevel with a canvas
	catch {destroy .dummy}
	toplevel .dummy
	canvas .dummy.c -borderwidth 0
	pack .dummy.c -expand 1 -fill both

	# recreate all objects
  set minx 0
  set miny 0
  foreach n [lsort [allEntries P]] {
		set tmp [util::oneLine $plugin($n,p_prompt) [ini::Str Graphics.canvasDisplayLength]]
		set color [ini::Str common.colorP]
		if {$plugin($n,p_start)==1} {set color [ini::Str common.colorP1]}
		createBox .dummy.c \
			$plugin($n,x) $plugin($n,y) \
			$color \
			$n \
			"Prompt $n" \
			"[string range $plugin($n,p_title) 0 [ini::Str Graphics.canvasDisplayLength]]\n$tmp" \
			[expr \$plugin($n,p_follows)=={}] \
			[expr \$plugin($n,p_vxml)==1]
		if {$plugin($n,x)>$minx} {set minx $plugin($n,x)}
		if {$plugin($n,y)>$miny} {set miny $plugin($n,y)}
  }
  foreach n [lsort [allEntries Q]] {
		set tmp [util::oneLine $plugin($n,q_init) [ini::Str Graphics.canvasDisplayLength]]
			createBox .dummy.c \
			$plugin($n,x) $plugin($n,y) \
			[ini::Str common.colorQ] \
			$n \
			"Question $n" \
			"[string range $plugin($n,q_title) 0 [ini::Str Graphics.canvasDisplayLength]]\n$tmp" \
			[expr \$plugin($n,q_follows)=={}] \
			[expr \$plugin($n,q_vxml)==1]
		if {$plugin($n,x)>$minx} {set minx $plugin($n,x)}
		if {$plugin($n,y)>$miny} {set miny $plugin($n,y)}
  }

	# recreate all connections
  foreach n [lsort [allEntries P]] {
		foreach tmp $plugin($n,p_follows) {
			connectRectangles .dummy.c $n $tmp last [lineColor $n $tmp]
		}
  }
  foreach n [lsort [allEntries Q]] {
		foreach tmp $plugin($n,q_follows) {
			connectRectangles .dummy.c $n $tmp last [lineColor $n $tmp]
		}
  }
  
  # adjust the size of the snapshot window to contain the whole picture
  #wm geometry .dummy 400x400+10+10
	raise .dummy
	grab .dummy
	graf::captureCanvas .dummy.c $fn 20 $type
	grab release .dummy  
  catch {destroy .dummy}
}